package jlegocom;

import java.util.*;

/***************************************************************************
*The PING-Thread pings all connected Event-Adapters every 30 seconds to get
*sure that adpters are still connected and ready to send and receive commands.
****************************************************************************/
public class Ping extends Object implements Runnable
{
	LegoAdapter adapter;
	private static final int PAUSE = 30000;
	private volatile Thread t;
	private static final boolean DEBUG = false;
	      
	public Ping(LegoAdapter adapter)
	{
		this.adapter=adapter;
	}
	
	/*************************************************************************
   *Start-method of Ping-Thread.
  *************************************************************************/
	public void start()
	{
		t = new Thread(this);
		t.start();
		if (DEBUG) System.out.println("***PING started!...");
	}
	
	/*************************************************************************
   *Stop-method of Ping-Thread.
  *************************************************************************/
	public void stop()
	{
		t=null;
		if (DEBUG) System.out.println("***PING stopped!...");
	}
	
	/*************************************************************************
   *Run-method of Ping-Thread.
  *************************************************************************/
	public void run()
	{
		DelegateEventThread commT;
		Thread thisThread = Thread.currentThread();
		String pingActRobo = new String("PING robot");
					
		while(t==thisThread){
			try{
				System.out.println("  ***PING running ... TIME:"+new Date());
				
				for (int i = 0; i < adapter.commThreads.size(); i++){
					commT = (DelegateEventThread)adapter.commThreads.elementAt(i);
					if (commT.isOK()){
						String pingAct = new String("PING "+commT.getHostName());
						System.out.println("  ***trying to send to adapter: "+commT.getName()+" CMD:"+pingAct);
						commT.setNotOK();
						
						Vector help = new Vector();
						help.addElement(commT.getHostName());
						
						if (!adapter.sendToAdapterX(commT.getHostName(), commT.getName(), pingAct)){
							System.out.println("  ***APPLET not VALID -> killing ");
							adapter.stopMe(commT);
							if (commT.getName().equals(adapter.theChiefApplet.getName())) adapter.forgetControl();
						}
					}
					else{
						System.out.println("  ***APPLET not VALID -> killing ");
						adapter.stopMe(commT);
						if (commT.getName().equals(adapter.theChiefApplet.getName())) adapter.forgetControl();
					}
				}
				if (adapter.robotAlive()){
					if (adapter.robotThread.isOK()){
						System.out.println("  ***trying to send to ROBOT: "+pingActRobo);
						adapter.robotThread.setNotOK();
						
						if (!adapter.sendToRobot(pingActRobo)){
							System.out.println("  ***ROBOT not VALID -> killing ");
							adapter.stopRobotThread();
						}
					}
					else{
						System.out.println("  ***ROBOT not VALID -> killing ");
						adapter.stopRobotThread();
					}
				}

				thisThread.sleep(PAUSE);
			}
			catch(InterruptedException e){}
		}
	}
}

