package jlegocom;

import java.io.*;
import java.util.*;
import java.net.*;

/******************************************************************
******************************************************************/

public class RobotEventAdapter extends Thread
{
  static final int DELEGATE_PORT = 6133;
  Socket socket;
  ObjectInputStream oInStr;
  ObjectOutputStream oOutStr;
	boolean running = false;
	private static final String PING_EVT = new String("PING");

  RobotJavaListener client;

  /*************************************************************************
  *************************************************************************/
  public RobotEventAdapter(String host, RobotJavaListener listener)
	{
		this.client = listener;
		
    try{
      socket = new Socket(host, DELEGATE_PORT); 
      oInStr = new ObjectInputStream(socket.getInputStream());
      oOutStr = new ObjectOutputStream(socket.getOutputStream());
			System.out.println(this.getName()+": O EventAdapter connected!");
			
			running = true;
    }
		catch(IOException e){
      System.out.println(this.getName()+": X Problem while LegoAdapter connected: "+e);
    }
  }

  /*****************************************************************
	******************************************************************/
  public void run()
	{
    try {
			while(running){
			try{	
				//System.out.println(this.getName()+": waiting for object from javaConsole...");
        String cmd = (String)oInStr.readObject();
				System.out.println(this.getName()+": READ FROM ADAPTER: <"+cmd+">");
        
				if (cmd != null){				
					if (cmd.startsWith(PING_EVT)){
						//send reply to legoAdapter
						this.send(PING_EVT);
					}
					else
						this.client.cmdReceived(cmd);
				}
			}
			catch(IOException e){
				System.out.println(this.getName()+": Couldn't get I/O for connection: "+e);
				running = false;
			}
  	  }
		}
		catch(ClassNotFoundException e){
			System.out.println(this.getName()+": "+e);
			//System.exit(1);		
		}
		finally{
			try{ if (socket != null) socket.close(); }
			catch(IOException e){}
		}
		//this.destroy();
  }

  /*****************************************************************
	******************************************************************/
  public void destroy()
	{
		System.out.println(this.getName()+": destroyed!");
	
		try{
			socket.close();
			socket = null;
			oInStr.close();
			oInStr = null;
  		oOutStr.close();
			oOutStr = null;
		}
		catch(IOException e){
			System.out.println(this.getName()+": "+e);
		}
  }


  /*****************************************************************
	******************************************************************/
  public void send(String cmd)
	{
    try {
			if (running){
      	this.oOutStr.writeObject(cmd);
				System.out.println(this.getName()+": SENT TO ADAPTER: <"+cmd+">");
			}
			else{
				System.out.println(this.getName()+": no connection for sending command!");
				this.client.cmdReceived("JLEGO OUT");
			}
		}
		catch(IOException e){
			System.out.println(this.getName()+": X Send to LegoAdapter failed: "+e);
		}
  }
	
	/*************************************************************************
  *************************************************************************/	
	public String getHostName()
	{
		if (socket != null)
			return(this.socket.getInetAddress().getHostName());
		else
			return("");
	}
}
